Loading...
Searching...
No Matches
seqan3::dssp9 Class Reference
Alphabet » Structure

The protein structure alphabet of the characters "HGIEBTSCX". More...

`#include <seqan3/alphabet/structure/dssp9.hpp>`

Inheritance diagram for seqan3::dssp9:
[legend]

## Public Member Functions

Constructors, destructor and assignment
constexpr | dssp9 () noexcept=default
| Defaulted.
constexpr | dssp9 (dssp9 const &) noexcept=default
| Defaulted.
constexpr | dssp9 (dssp9 &&) noexcept=default
| Defaulted.
constexpr dssp9 & | operator= (dssp9 const &) noexcept=default
| Defaulted.
constexpr dssp9 & | operator= (dssp9 &&) noexcept=default
| Defaulted.
| ~dssp9 () noexcept=default
| Defaulted.
Public Member Functions inherited from seqan3::alphabet_base< dssp9, 9 >
constexpr | alphabet_base () noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base const &) noexcept=default
| Defaulted.
constexpr | alphabet_base (alphabet_base &&) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base const &) noexcept=default
| Defaulted.
constexpr alphabet_base & | operator= (alphabet_base &&) noexcept=default
| Defaulted.
| ~alphabet_base () noexcept=default
| Defaulted.
constexpr char_type | to_char () const noexcept
| Return the letter as a character of char_type.
constexpr rank_type | to_rank () const noexcept
| Return the letter's numeric value (rank in the alphabet).
constexpr dssp9 & | assign_char (char_type const chr) noexcept
| Assign from a character, implicitly converts invalid characters.
constexpr dssp9 & | assign_rank (rank_type const c) noexcept
| Assign from a numeric value.

## Related Symbols

(Note that these are not member symbols.)
Structure literals
constexpr dssp9 | operator""_dssp9 (char const ch) noexcept
| The seqan3::dssp9 char literal.
constexpr std::vector< dssp9 > | operator""_dssp9 (char const *str, std::size_t len)
| The seqan3::dssp9 string literal.

## Additional Inherited Members

Static Public Attributes inherited from seqan3::alphabet_base< dssp9, 9 >
static constexpr detail::min_viable_uint_t< size > | alphabet_size
| The size of the alphabet, i.e. the number of different values it can take.
Protected Types inherited from seqan3::alphabet_base< dssp9, 9 >
using | char_type
| The char representation; conditional needed to make semi alphabet definitions legal.
using | rank_type
| The type of the alphabet when represented as a number (e.g. via to_rank()).

## Detailed Description

The protein structure alphabet of the characters "HGIEBTSCX".

The DSSP annotation links structure elements to protein sequences. Originally created with 7 letters as a file format for the DSSP program (https://swift.cmbi.umcn.nl/gv/dssp/), it is also used in the stockholm file format for structure alignments, extended by the characters C and X (https://en.wikipedia.org/wiki/Stockholm_format).

The letter abbreviations are as follows:

H = alpha helix B = beta bridge E = strand G = helix-3 I = helix-5 T = turn S = bend C = coil/loop X = unknown

### Example

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/structure/dssp9.hpp>
#include <seqan3/core/debug_stream.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dssp9 letter{'H'_dssp9};
letter.assign_char('B');
seqan3::debug_stream << letter << '\n'; // prints "B"
letter.assign_char('F'); // Unknown characters are implicitly converted to 'X'.
seqan3::debug_stream << letter << '\n'; // prints "X"
}
seqan3::alphabet_base::assign_char
constexpr derived_type & assign_char(char_type const chr) noexcept
Assign from a character, implicitly converts invalid characters.
Definition alphabet_base.hpp:160
seqan3::dssp9
The protein structure alphabet of the characters "HGIEBTSCX".
Definition dssp9.hpp:59
debug_stream.hpp
Provides seqan3::debug_stream and related types.
dssp9.hpp
Provides the dssp format for protein structure.
seqan3::debug_stream
debug_stream_type debug_stream
A global instance of seqan3::debug_stream_type.
Definition debug_stream.hpp:38
seqan3::literals
The SeqAn namespace for literals.

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## Friends And Related Symbol Documentation

## operator""_dssp9() [1/2]

std::vector< dssp9 > operator""_dssp9 | ( | char const * | str,
|  | std::size_t | len )

related

The seqan3::dssp9 string literal.

Parameters

  [in] | str | A pointer to the character string to assign.
  [in] | len | The size of the character string to assign.

Returns
  std::vector<seqan3::dssp9>

You can use this string literal to easily assign to std::vector<seqan3::dssp9>:

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/structure/dssp9.hpp>
int main()
{
using namespace seqan3::literals;
std::vector<seqan3::dssp9> sequence1{"EHHHHT"_dssp9};
std::vector<seqan3::dssp9> sequence2 = "EHHHHT"_dssp9;
auto sequence3 = "EHHHHT"_dssp9;
}
std::vector

This entity is experimental and subject to change in the future. Experimental since version 3.1.

## operator""_dssp9() [2/2]

dssp9 operator""_dssp9 | ( | char const | ch | ) |

related

The seqan3::dssp9 char literal.

Parameters

  [in] | ch | The character to represent as dssp.

Returns
  seqan3::dssp9

You can use this char literal to assign a seqan3::dssp9 character:

// SPDX-FileCopyrightText: 2006-2025 Knut Reinert & Freie Universität Berlin
// SPDX-FileCopyrightText: 2016-2025 Knut Reinert & MPI für molekulare Genetik
// SPDX-License-Identifier: CC0-1.0
#include <seqan3/alphabet/structure/dssp9.hpp>
int main()
{
using namespace seqan3::literals;
seqan3::dssp9 letter1{'('_dssp9};
auto letter2 = '('_dssp9;
}

This entity is experimental and subject to change in the future. Experimental since version 3.1.

The documentation for this class was generated from the following file:

- dssp9.hpp

Hide me